/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Acts as a place for all the 'interchangable' parts to go.
 * In other words,graphics,music,gamestate...
 * @author matt
 */
public class Game {
    public IGraphicsDriver graphics;
    public IMusicDriver music;
    public IGame gamestate;
    private long startup,currentframe;
    public void Reset()
    {
            startup=System.currentTimeMillis();
            currentframe=0;
            //gamestate=new swimikachan.games.OpeningGame();
            GameState gs=new GameState();
        try {
            gs.map.LoadBitmap(new FileInputStream("Pbm/Map1.pbm"));
            gs.npcs.Load(new FileInputStream("NPChar.dat"));
        } catch (Exception ex) {
            Logger.getLogger(Game.class.getName()).log(Level.SEVERE, null, ex);
        }
            gamestate=new javachan.games.EditorGame(gs);
    }
    public void RunFrame() {
        long time=System.currentTimeMillis();
        time-=startup;

        long delta=time;
        delta-=currentframe;
        currentframe=time;
        gamestate.Run(((double)delta)/1000.0, ((double)time)/1000.0, this);
    }
}
