/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.blocks;


import javachan.IGraphicsDriver;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class FilterBlockType extends BasicBlockType {
    @Override
    protected String GetBlockImage()
    {
        return "Pbm/Prtfilt.pbm";
    }
    //Does colliding with this halt Ikachan?
    @Override
    public boolean CollisionStops()
    {
        return false;
    }

    @Override
    public Rect GetCollision(int x,int y,int subtype)
    {
        return new Rect(x*16,y*16,16,16);
    }
    //Draws this block at a specific pixel position.Note that pass is 0 or 1(0 is back,1 is fore)
    @Override
    public void Draw(int pass,int ox,int oy,int subtype,IGraphicsDriver igd,double Time)
    {
        if (pass!=1) return;
        igd.BlitBCKImage(16*subtype, 0, 16, 16, ox, oy, igd.GetImage(GetBlockImage(), 0, 0, 0));
    }
    
}
