/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.games.editorui;

import javachan.IGraphicsDriver;
import javachan.IGraphicsDriver.IImage;

/**
 *
 * @author matt
 */
public class UIButton extends UIElement {
    public IImage Image;
    public int ImageX,ImageY;
    public Runnable OnClick;
    public double PressedTime=0;
    @Override
    public void UpdateAndDraw(int ox, int oy,double DeltaTime,boolean selected, IGraphicsDriver igd) {
        if (PressedTime>0)
        {
            PressedTime-=DeltaTime;
        }
        igd.BlitImage(ImageX, ImageY, Bounds.width, Bounds.height, ox, oy+(PressedTime>0?4:0), Image);
    }

    @Override
    public int HandleClick(int x, int y) {
        OnClick.run();
        PressedTime=0.5;
        return 0;
    }
    
}
