/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.games.editorui;

import javachan.IGraphicsDriver;
import javachan.Rect;

/**
 *
 * @author matt
 */
public abstract class UIElement {
    protected Rect Bounds=new Rect(0,0,1,1);
    public void SetBounds(Rect r) {
        Bounds=new Rect(r.x,r.y,r.width,r.height);
    }
    public Rect GetBounds() {
        Rect r=new Rect(Bounds.x,Bounds.y,Bounds.width,Bounds.height);
        return r;
    }
    public abstract void UpdateAndDraw(int ox,int oy,double DeltaTime,boolean selected,IGraphicsDriver igd);
    //Returns a value for the Numpad subsystem.
    public abstract int HandleClick(int x,int y);
    public void HandleDrag(int x,int y) {}
}
