/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.games.editorui;

import javachan.IGraphicsDriver;
import javachan.IGraphicsDriver.IImage;
import javachan.games.EditorGame;

/**
 * Width == Maximum+16.
 * @author matt
 */
public class UIScrollbar extends UIElement {
    public int Value=0;
    @Override
    public void UpdateAndDraw(int ox, int oy, double DeltaTime, boolean selected, IGraphicsDriver igd) {
        IImage ii=igd.GetImage("TileEditor.png", 0, 0, 0);
        for (int p=0;p<Bounds.width;p++)
        {
        igd.BlitImage(174, 0, 1, 16, ox+p, oy, ii);
        }
        igd.BlitImage(172, 0, 2, 16, ox, oy, ii);
        igd.BlitImage(172, 0, 2, 16, ox+(Bounds.width-2), oy, ii);
        igd.BlitImage(160, 0, 12, 12, (ox+2+Value), oy+2, ii);
    }

    @Override
    public int HandleClick(int x, int y) {
    return 0;
    }
    @Override
    public void HandleDrag(int x,int y)
    {
        Value=x-8;
        if (Value<0) Value=0;
        if (Value>Bounds.width-16) Value=Bounds.width-16;
    }
}
