/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author matt
 */
public class CacheImagesGraphicsDriver implements IGraphicsDriver {
    public IGraphicsDriver parent;
    public Map<String,IImage> images=new HashMap();
    public CacheImagesGraphicsDriver(IGraphicsDriver p)
    {
        parent=p;
    }
    @Override
    public IImage GetImage(String a,int tr,int tg,int tb) {
        if (images.containsKey(a+":"+tr+":"+tg+":"+tb))
            return images.get(a+":"+tr+":"+tg+":"+tb);
        
        IImage b=parent.GetImage(a,tr,tg,tb);
        images.put(a+":"+tr+":"+tg+":"+tb, b);
        return b;
    }

    @Override
    public void BlitImage(int srcx,int srcy,int srcw,int srch,int x, int y, IImage i) {
        parent.BlitImage(srcx,srcy,srcw,srch,x, y, i);
    }
    @Override
    public void BlitBCKImage(int srcx,int srcy,int srcw,int srch,int x, int y, IImage i) {
        parent.BlitBCKImage(srcx,srcy,srcw,srch,x, y, i);
    }

    @Override
    public void Flush() {
        parent.Flush();
    }

    @Override
    public void Clear(int i, int i0, int i1) {
        parent.Clear(i, i0, i1);
    }

    @Override
    public int GetWidth() {
        return parent.GetWidth();
    }

    @Override
    public int GetHeight() {
        return parent.GetHeight();
    }

    @Override
    public void Display8pxText(int x, int y, int r, int g, int b, String text) {
        parent.Display8pxText(x, y, r, g, b, text);
    }

    @Override
    public int GetMouseX() {
        return parent.GetMouseX();
    }

    @Override
    public int GetMouseY() {
        return parent.GetMouseY();
    }

    @Override
    public int GetMouseButton() {
        return parent.GetMouseButton();
    }

    @Override
    public boolean StillRunning() {
        return parent.StillRunning();
    }

    @Override
    public void UsingNumpad(boolean using) {
        parent.UsingNumpad(using);
    }

    @Override
    public int GetNumpadNumber() {
        return parent.GetNumpadNumber();
    }

    @Override
    public void SetNumpadNumber(int i) {
        parent.SetNumpadNumber(i);
    }


    @Override
    public boolean IsKeyDown(int KEYID) {
        return parent.IsKeyDown(KEYID);
    }

    @Override
    public boolean IsKeyJustPressed(int KEYID) {
        return parent.IsKeyJustPressed(KEYID);
    }

    @Override
    public boolean GetMouseDown() {
        return parent.GetMouseDown();
    }

    @Override
    public boolean GetMouseJustDown() {
        return parent.GetMouseJustDown();
    }
    
}
