/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.blocks;

import javachan.GameState;
import javachan.IGraphicsDriver;
import javachan.IGraphicsDriver.IImage;

/**
 *
 * @author matt
 */
public class DirectionBlockType extends BasicBlockType {
    @Override
    public int GetAmountOfSubTypes(IGraphicsDriver igd)
    {
        return 4;
    }    
    @Override
    protected String GetBlockImage()
    {
        return "Pbm/PrtDir.pbm";
    }
    //TODO:Pushy Directions
    @Override
    public boolean CollisionStops() {return false;}
    @Override
    public void Draw(int pass,int ox,int oy,int sub,IGraphicsDriver gd,double Time)
    {
        if (pass!=0) return;
        IImage img=gd.GetImage(GetBlockImage(), 0,0,0);
        
        if (sub==0)
            gd.BlitBCKImage((int)((Time-Math.floor(Time))*64)%16,0, 16, 16, ox, oy, img);
        if (sub==1)
            gd.BlitBCKImage(((int)(1.0-(Time-Math.floor(Time))*64)%16)+16,0, 16, 16, ox, oy, img);
        if (sub==2)
            gd.BlitBCKImage(0,(int)((Time-Math.floor(Time))*64)%16, 16, 16, ox, oy, img);
        if (sub==3)
            gd.BlitBCKImage(0,((int)(1.0-(Time-Math.floor(Time))*64)%16)+16, 16, 16, ox, oy, img);
            
    }
}
