/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.games.editorui;

import javachan.GameStateNPChar.NPCCharacter;
import javachan.IGraphicsDriver;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class UINPCTypes extends UIPanel {
    public int SelectedType=0;
    public int SelectedSubType=0;
    public Runnable OnChange;
    public UINPCTypes()
    {
        super();
        Elements.add(NPC_SCROLLBAR);
    }
    public UIScrollbar NPC_SCROLLBAR=new UIScrollbar();
    public int ScrollbarScale=4;
    //This is for the really nice NPC scroll thing.
    //For IdioticBaka1824
    public int[] NPCTypes =          {0, 1, 1, 1, 1, 1, 2, 3, 4, 5,6,6,6, 7, 8, 9};
    public int[] NPCSubTypes =       {0, 0, 1, 2, 3, 4, 0, 0, 0, 0,0,1,2, 0, 0, 0};
    //Types that have no subtypes(and thus subtype should be ignored)
    public boolean[] NPCSubTypeLess= {true,false,true,true,true,true,false,true,true,true};
    @Override
    public void UpdateAndDraw(int ox, int oy, double DeltaTime, boolean selected, IGraphicsDriver igd) {
        //UINPCTYPES LAYOUT CODE
        int roomneeded=NPCTypes.length;
        roomneeded-=(Bounds.width/32);
        if (roomneeded<0) roomneeded=0;
        NPC_SCROLLBAR.SetBounds(new Rect(0,Bounds.height-16,(roomneeded*ScrollbarScale)+16,16));
        //--END UINPCTYPES LAYOUT CODE
        super.UpdateAndDraw(ox, oy, DeltaTime, selected, igd);
        for (int p=0;p<Bounds.width/32;p++)
        {
            int i=p+(NPC_SCROLLBAR.Value/ScrollbarScale);
            if (i>=NPCTypes.length) break;
            if (i<0) continue;
            NPCCharacter npcc=new NPCCharacter();
            npcc.Exists=true;
            npcc.Type=NPCTypes[i];
            npcc.OX=NPCSubTypes[i];
            int ooy=0;
            if (SelectedType==NPCTypes[i])
            {
            if ((SelectedSubType==NPCSubTypes[i])||(NPCSubTypeLess[SelectedType]))
            {
                ooy=8;
            }
            }
            igd.BlitImage(256, 0, 16, 16, ox+8+(32*p), oy+ooy+16, igd.GetImage("TileEditor.png", 0, 0, 0));
            npcc.Draw(ox+8+(32*p), oy+ooy+16, DeltaTime, igd);
        }
    }
    @Override
    public int HandleClick(int x, int y) {
        if (y<Bounds.height-16)
        {
            int i=(x/32)+(NPC_SCROLLBAR.Value/ScrollbarScale);
            if (i<0)
                return 0;
            if (i>=NPCTypes.length)
                return 0;
            SelectedType=NPCTypes[i];
            SelectedSubType=NPCSubTypes[i];
            OnChange.run();
            return 0;
        }
    return super.HandleClick(x,y);
    }

}
